const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const departments = sequelize.define(
    'departments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  departments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.departments.hasMany(db.approval_steps, {
      as: 'approval_steps_approver_department',
      foreignKey: {
          name: 'approver_departmentId',
      },
      constraints: false,
    });









    db.departments.hasMany(db.allocations, {
      as: 'allocations_department',
      foreignKey: {
          name: 'departmentId',
      },
      constraints: false,
    });



    db.departments.hasMany(db.procurement_plans, {
      as: 'procurement_plans_department',
      foreignKey: {
          name: 'departmentId',
      },
      constraints: false,
    });


    db.departments.hasMany(db.requisitions, {
      as: 'requisitions_requesting_department',
      foreignKey: {
          name: 'requesting_departmentId',
      },
      constraints: false,
    });
































//end loop



    db.departments.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.departments.belongsTo(db.departments, {
      as: 'parent_department',
      foreignKey: {
        name: 'parent_departmentId',
      },
      constraints: false,
    });




    db.departments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.departments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return departments;
};


